//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "Unit3.h"
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

AI::AI()
{
 stop=false;
}

bool AI::Solve(char* Str,int Size,const char* Num,int Numsize)
{
 timer=clock();
 bool res=false;
 size=Size;
 numsize=Numsize;
 str=Str; // 
 num=(char*)Num; //  
 var=new char[size]; // 
 memset(var,2,size);
 mat=new char[size]; //  
 memset(mat,-1,size);
 pos=new char[numsize]; //  
 int i,j;
 pos[0]=0;
 for(i=1;i<numsize;i++)
  pos[i]=pos[i-1]+num[i-1]+1;
 for(i=0;i<numsize;i++)
  for(j=0;j<num[i];j++)
   var[pos[i]+j]=1;  // 
 do
 {
  if(Match()) //     
   Mask(); //     
  if(clock()-timer>1000)
  {
   Application->ProcessMessages();
   timer=clock();
  }
 }
 while(!stop&&Next()); //    
 if(!stop&&Merge()) //      
  res=true;  //   
 delete [] mat;
 delete [] var;
 return res;
}

bool AI::Next() //   
{
 int i,j,k;
 //char prepos;
 for(i=0;i<numsize;i++)
 {
  //prepos=pos[i];
  if( ((i<numsize-1)&&(pos[i]+num[i]+1<pos[i+1])) ||
      ((i==numsize-1)&&(pos[i]+num[i]<size))) //  
  {
   pos[i]++;     //
   memset(var,2,size);
   for(j=0;j<numsize;j++)
    for(k=0;k<num[j];k++)
     var[pos[j]+k]=1;
   return true;
  }
  else       // 
  {
   if(i==numsize-1) return false; //    
   if(i>0) pos[i]=pos[i-1]+num[i-1]+1;
   else pos[i]=0;       //    
   /*if(pos[i]==prepos&&i==numsize-1) //  
    return false;*/
  }
 }
}

bool AI::Match() //   
{
 for(int i=0;i<size;i++)
  switch(str[i])
  {
   case 0: break;
   case 1: if(var[i]!=1) return false; break;
   case 2: if(var[i]==1) return false; break;
  }
 return true; 
}

void AI::Mask() //    
{
 for(int i=0;i<size;i++)
  switch(mat[i])
  {
   case -1: mat[i]=var[i]; break;
   case 0: break;
   case 1: if(var[i]==2) mat[i]=0; break;
   case 2: if(var[i]==1) mat[i]=0; break;
  }
}

bool AI::Merge() //     
{
 bool res=false;
 for(int i=0;i<size;i++)
  if(mat[i]&&str[i]==0)
  {
   res=true;
   str[i]=mat[i];
  }
 return res; 
}

void AI::Stop()
{
 stop=true;
}

